"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Array_1 = require("fp-ts/lib/Array");
var Monoid_1 = require("fp-ts/lib/Monoid");
var pipeable_1 = require("fp-ts/lib/pipeable");
var monoidAllFoldMap = Array_1.foldMap(Monoid_1.monoidAll);
function _allPass(predicates, val) {
    return pipeable_1.pipe(predicates, monoidAllFoldMap(function (predicate) { return predicate(val); }));
}
function allPass(predicates, val) {
    if (val === undefined) {
        return function (val) { return _allPass(predicates, val); };
    }
    else {
        return _allPass(predicates, val);
    }
}
exports.allPass = allPass;
