"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Array_1 = require("fp-ts/lib/Array");
var Monoid_1 = require("fp-ts/lib/Monoid");
var pipeable_1 = require("fp-ts/lib/pipeable");
var monoidAnyFoldMap = Array_1.foldMap(Monoid_1.monoidAny);
function _anyPass(predicates, val) {
    return pipeable_1.pipe(predicates, monoidAnyFoldMap(function (predicate) { return predicate(val); }));
}
function anyPass(predicates, val) {
    if (val === undefined) {
        return function (val) { return _anyPass(predicates, val); };
    }
    else {
        return _anyPass(predicates, val);
    }
}
exports.anyPass = anyPass;
